package org.dromara.system.service;

import org.dromara.common.core.domain.R;
import org.dromara.system.domain.vo.GameEventVo;
import org.dromara.system.domain.bo.GameEventBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 赛事基本信息Service接口
 *
 * @author zlt
 * @date 2025-07-30
 */
public interface IGameEventService {

    /**
     * 查询赛事基本信息
     *
     * @param eventId 主键
     * @return 赛事基本信息
     */
    GameEventVo queryById(Long eventId);

    /**
     * 分页查询赛事基本信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 赛事基本信息分页列表
     */
    TableDataInfo<GameEventVo> queryPageList(GameEventBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的赛事基本信息列表
     *
     * @param bo 查询条件
     * @return 赛事基本信息列表
     */
    List<GameEventVo> queryList(GameEventBo bo);

    /**
     * 新增赛事基本信息
     *
     * @param bo 赛事基本信息
     * @return 是否新增成功
     */
    Long insertByBo(GameEventBo bo);

    /**
     * 修改赛事基本信息
     *
     * @param bo 赛事基本信息
     * @return 是否修改成功
     */
    Boolean updateByBo(GameEventBo bo);

    /**
     * 校验并批量删除赛事基本信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 获取赛事ID与名称的映射关系
     *
     * @return 赛事ID与名称的映射关系
     */
    Map<String, Long> getEventIdNameMap();

    /**
     * 初始化赛事信息
     */
    void init();

    /**
     * 获取默认赛事信息
     *
     * @return 默认赛事信息
     */
    GameEventVo getDefaultEvent();

    /**
     * 更新赛事默认赛事状态
     *
     * @param bo 赛事基本信息
     * @return 更新记录数
     */
    int updateEventDefault(GameEventBo bo);

    /**
     * 统计赛事个数
     * @return
     */
    Long countGameEvent(Long type);
}
